; LDE
; UM, MI
; (c) Indy, 2011.
;
	.686p
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

.code
TestIp:
	mov Dr7,ecx
		
MAX_INSTRUCTION_LENGTH	equ 15

MODRM_REG_MASK		equ 00111000B
EXCEPTION_CHAIN_END	equ -1

OP_INTN		equ 0CDH
OP_SYSENTER	equ 340FH
OP_POPSS		equ 17H
OP_LSS		equ 0B20FH
OP_IRET		equ 0CFH
OP_RET		equ 0C3H
OP_RETN		equ 0C2H
OP_RETF		equ 0CBH
OP_ENTER		equ 0C8H
OP_LEAVE		equ 0C9H

; +
; Buffer -   MAX_INSTRUCTION_LENGTH   RWE,     NOACCESS.
;
	assume fs:nothing
LDE proc uses ebx esi edi Buffer:PVOID, Address:PVOID
Local Ip:PVOID	;    .
Local Instruction[(MAX_INSTRUCTION_LENGTH + 11B) and NOT(11B)]:BYTE	;      .
Local Prefixes:ULONG	;  .
Local PfxMask:DWORD	;    0x66, 0x67.
Local Ips:ULONG	;   .
Local PfxTable[8]:BYTE
Local SpTable[8]:BYTE
	cld
	xor edx,edx
	mov dword ptr [PfxTable],02EF3F2F0H	; LOCK, REPNZ, REP, CS
	mov dword ptr [PfxTable + 4],06426363EH	; DS, SS, ES, FS
	mov esi,Address
NextIp:
	lodsb
	cmp al,PREFIX_GS	; GS
	mov ecx,8
	je NextPfx
	lea edi,PfxTable
	.if al == 66H
		bts PfxMask,0
		jmp NextPfx
	.elseif al == 67H
		bts PfxMask,1
		jmp NextPfx
	.endif
	repne scasb
	jne @f
NextPfx:
	inc edx
	cmp edx,MAX_INSTRUCTION_LENGTH
	jb NextIp
	; Invalid opcode
@@:
	mov ax,word ptr [esi]	; ah
	mov Prefixes,edx
	mov Ips,2	
; Esi -   .
	lea edi,Instruction
	mov al,PREFIX_DS	; DS
	stosb
	mov dword ptr [SpTable],33231303H	; ADD, ADC, AND, XOR
	mov dword ptr [SpTable + 4],008D8B87H	; XCHG, MOV, LEA
; MOVZX, XADD, NOT etc  ,       Esp.
	mov al,66H
	bt PfxMask,0
	.if Carry?
		inc Ips
		stosb
	.endif
	inc al
	bt PfxMask,1
	.if Carry?
		inc Ips
		stosb
	.endif
	not edx
	dec esi
	lea ecx,[edx + MAX_INSTRUCTION_LENGTH + 1]	;   .
	mov edx,edi
	rep movsb
	push ebp
	Call @f
Safe:
	pop dword ptr fs:[0]
	lea esp,[esp + 2*4]
	pop ebp
	ret
@@:
	Call @f
; SEH()
	push ebp
	mov edx,dword ptr [esp + 2*4]
	assume edx:PEXCEPTION_RECORD
	mov esi,dword ptr [esp + 3*4]	; EstablisherFrame
	mov ebp,dword ptr [esi + 3*4]	; Ebp
	mov eax,Buffer
	add eax,MAX_INSTRUCTION_LENGTH
	.if [edx].ExceptionCode == STATUS_ACCESS_VIOLATION
		.if [edx].ExceptionInformation[4] == eax
			sub eax,Ips
			.if [edx].ExceptionAddress == eax
				inc Ips
				mov esp,esi
				cmp Ips,MAX_INSTRUCTION_LENGTH
				jb Iter
				xor eax,eax
				jmp Safe
			.endif
		.endif
	.elseif [edx].ExceptionCode == STATUS_SINGLE_STEP
	;     .    ,       (W8)  .     #DB 
	;    TF  KiUserExceptionDispatcher().     -  ,    . 
	;     .      Ip ~ Ki(),   Ip   ( 
	;   -    TF   Eip).           
	;  ,       -    .
	;    Ss.     .
		mov eax,fs:[TEB.Peb]
		mov eax,PEB.Ldr[eax]
		mov eax,PEB_LDR_DATA.InLoadOrderModuleList.Flink[eax]
		mov eax,LDR_DATA_TABLE_ENTRY.InLoadOrderModuleList.Flink[eax]	; ntdll.dll
		mov ecx,LDR_DATA_TABLE_ENTRY.DllBase[eax]
		.if [edx].ExceptionAddress > ecx
			add ecx,LDR_DATA_TABLE_ENTRY.SizeOfImage[eax]
			.if eax < ecx
				mov eax,dword ptr [esp + 4*4]	; PCONTEXT
				and CONTEXT.regEFlags[eax],NOT(EFLAGS_TF)	;  .
				pop ebp
				mov eax,EXCEPTION_CONTINUE_SEARCH
				retn 4*4
			.endif
		.endif
	.endif
	mov esp,esi
Load:
	mov eax,Ips
	bt PfxMask,0
	.if Carry?
		dec eax
	.endif
	bt PfxMask,1
	.if Carry?
		dec eax
	.endif
	dec eax	; !Ds
	add eax,Prefixes
	jmp Safe
@@:
	push dword ptr fs:[TEB.Tib.ExceptionList]
Iter:
	mov dword ptr fs:[TEB.Tib.ExceptionList],esp
	movzx eax,word ptr [edx]	;   ModR/M.
	lea edi,SpTable
	cmp al,OP_POPSS
	mov ecx,7
	je Load
	cmp al,OP_RET
	je Load
	cmp al,OP_IRET
	je Load
	cmp al,OP_RETF
	je Load
	cmp al,OP_LEAVE
	je Load
	inc Ips
	cmp al,OP_INTN
	je Load
	cmp ax,OP_SYSENTER
	je Load
	.if (al == OP_RETN) || (al == OP_ENTER)
		inc Ips
		jmp Load
	.endif
	dec Ips
	repne scasb
	.if Zero?	;   Esp/Sp  Eax/Ax.
		and byte ptr [edx + 1],NOT(MODRM_REG_MASK)	; 000B = Eax/Ax
	.elseif al == 0BCH	; mov Esp,imm32
		sub byte ptr [edx],(0BCH - 0B8H)	; Eax
	.elseif al == 8EH	; mov Sreg,r/m16
		and byte ptr [edx + 1],NOT(MODRM_REG_MASK)	; 000B = Es
	.elseif ax == OP_LSS
		add byte ptr [edx + 1],2	; LFS
	.endif
	xor eax,eax
	mov edi,Buffer
	lea esi,Instruction
	add edi,MAX_INSTRUCTION_LENGTH
; IRET-.
	push EFLAGS_TF or EFLAGS_IF or EFLAGS_MASK	; EFlags
	sub edi,Ips
	push Cs	; KGDT_R3_CODE or RPL_MASK
	mov ecx,Ips
	push edi	; Ip
	
	xor eax,eax
	xor ebx,ebx
	xor edx,edx
	xor ebp,ebp

	rep movsb
	
	mov es,ax
	mov ds,ax
	mov gs,ax
	mov fs,ax
	
	finit
	
	xor ecx,ecx
	xor esi,esi
	xor edi,edi
	
;       .
	BYTE OP_IRET	; Iretd
LDE endp

%NTERR macro
	.if Eax
	   Int 3
	.endif
endm

Entry proc
Local RegionBase:PVOID, RegionSize:ULONG
	mov RegionBase,NULL
	mov RegionSize,PAGE_SIZE*2
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr RegionBase, 0, addr RegionSize, MEM_RESERVE, PAGE_NOACCESS
	%NTERR
	mov RegionSize,PAGE_SIZE
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr RegionBase, 0, addr RegionSize, MEM_COMMIT, PAGE_READWRITE
	add RegionBase,X86_PAGE_SIZE - MAX_INSTRUCTION_LENGTH
	lea ebx,offset TestIp	; LDE
@@:
	invoke LDE, RegionBase, Ebx
	nop
;	add ebx,eax
;	.if byte ptr [ebx] == OP_IRET
;		Int 3
		ret
;	.endif
;	jmp @b
Entry endp
end Entry